package org.eclipse.jdt.internal.compiler.ast;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.eclipse.jdt.core.compiler.CharOperation;
import org.eclipse.jdt.internal.compiler.ASTVisitor;
import org.eclipse.jdt.internal.compiler.ast.ASTNode;
import org.eclipse.jdt.internal.compiler.ast.Assignment;
import org.eclipse.jdt.internal.compiler.ast.BinaryExpression;
import org.eclipse.jdt.internal.compiler.ast.CastExpression;
import org.eclipse.jdt.internal.compiler.ast.CompoundAssignment;
import org.eclipse.jdt.internal.compiler.ast.Expression;
import org.eclipse.jdt.internal.compiler.ast.FieldReference;
import org.eclipse.jdt.internal.compiler.ast.IntLiteral;
import org.eclipse.jdt.internal.compiler.ast.NameReference;
import org.eclipse.jdt.internal.compiler.ast.OperatorIds;
import org.eclipse.jdt.internal.compiler.ast.Reference;
import org.eclipse.jdt.internal.compiler.codegen.CodeStream;
import org.eclipse.jdt.internal.compiler.flow.FlowContext;
import org.eclipse.jdt.internal.compiler.flow.FlowInfo;
import org.eclipse.jdt.internal.compiler.flow.UnconditionalFlowInfo;
import org.eclipse.jdt.internal.compiler.impl.CompilerOptions;
import org.eclipse.jdt.internal.compiler.impl.Constant;
import org.eclipse.jdt.internal.compiler.lookup.BaseTypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.Binding;
import org.eclipse.jdt.internal.compiler.lookup.BlockScope;
import org.eclipse.jdt.internal.compiler.lookup.ClassScope;
import org.eclipse.jdt.internal.compiler.lookup.FieldBinding;
import org.eclipse.jdt.internal.compiler.lookup.InvocationSite;
import org.eclipse.jdt.internal.compiler.lookup.LocalVariableBinding;
import org.eclipse.jdt.internal.compiler.lookup.MethodBinding;
import org.eclipse.jdt.internal.compiler.lookup.MethodScope;
import org.eclipse.jdt.internal.compiler.lookup.ProblemReferenceBinding;
import org.eclipse.jdt.internal.compiler.lookup.ReferenceBinding;
import org.eclipse.jdt.internal.compiler.lookup.Scope;
import org.eclipse.jdt.internal.compiler.lookup.SourceTypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.TypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.VariableBinding;
import org.eclipse.jdt.internal.compiler.problem.AbortMethod;

public class SingleNameReference extends NameReference implements OperatorIds {
  public static final int READ = 0;
  
  public static final int WRITE = 1;
  
  public char[] token;
  
  public MethodBinding[] syntheticAccessors;
  
  public TypeBinding genericCast;
  
  public SingleNameReference(char[] source, long pos) {
    this.token = source;
    this.sourceStart = (int)(pos >>> 32L);
    this.sourceEnd = (int)pos;
  }
  
  public FlowInfo analyseAssignment(BlockScope currentScope, FlowContext flowContext, FlowInfo flowInfo, Assignment assignment, boolean isCompound) {
    UnconditionalFlowInfo unconditionalFlowInfo;
    FieldBinding fieldBinding;
    LocalVariableBinding localBinding;
    boolean isFinal, isReachable = ((flowInfo.tagBits & 0x3) == 0);
    if (isCompound) {
      FieldBinding fieldBinding1;
      LocalVariableBinding localVariableBinding;
      switch (this.bits & 0x7) {
        case 1:
          fieldBinding1 = (FieldBinding)this.binding;
          if (fieldBinding1.isBlankFinal() && 
            currentScope.needBlankFinalFieldInitializationCheck(fieldBinding1)) {
            FlowInfo fieldInits = flowContext.getInitsForFinalBlankInitializationCheck(fieldBinding1.declaringClass.original(), flowInfo);
            if (!fieldInits.isDefinitelyAssigned(fieldBinding1))
              currentScope.problemReporter().uninitializedBlankFinalField(fieldBinding1, (ASTNode)this); 
          } 
          manageSyntheticAccessIfNecessary(currentScope, flowInfo, true);
          break;
        case 2:
          if (!flowInfo.isDefinitelyAssigned(localVariableBinding = (LocalVariableBinding)this.binding))
            currentScope.problemReporter().uninitializedLocalVariable(localVariableBinding, (ASTNode)this); 
          if (localVariableBinding.useFlag != 1) {
            if (isReachable && (this.implicitConversion & 0x400) != 0) {
              localVariableBinding.useFlag = 1;
              break;
            } 
            if (localVariableBinding.useFlag <= 0)
              localVariableBinding.useFlag--; 
          } 
          break;
      } 
    } 
    if (assignment
      
      .expression != null)
      unconditionalFlowInfo = assignment.expression.analyseCode(currentScope, flowContext, flowInfo).unconditionalInits(); 
    switch (this.bits & 0x7) {
      case 1:
        manageSyntheticAccessIfNecessary(currentScope, (FlowInfo)unconditionalFlowInfo, false);
        fieldBinding = (FieldBinding)this.binding;
        if (fieldBinding.isFinal()) {
          if (!isCompound && fieldBinding.isBlankFinal() && currentScope.allowBlankFinalFieldAssignment(fieldBinding)) {
            if (unconditionalFlowInfo.isPotentiallyAssigned(fieldBinding)) {
              currentScope.problemReporter().duplicateInitializationOfBlankFinalField(fieldBinding, (Reference)this);
            } else {
              flowContext.recordSettingFinal((VariableBinding)fieldBinding, (Reference)this, (FlowInfo)unconditionalFlowInfo);
            } 
            unconditionalFlowInfo.markAsDefinitelyAssigned(fieldBinding);
            break;
          } 
          currentScope.problemReporter().cannotAssignToFinalField(fieldBinding, (ASTNode)this);
          break;
        } 
        if (!isCompound && (fieldBinding.isNonNull() || fieldBinding.type.isTypeVariable()) && 
          TypeBinding.equalsEquals((TypeBinding)fieldBinding.declaringClass, (TypeBinding)currentScope.enclosingReceiverType()))
          unconditionalFlowInfo.markAsDefinitelyAssigned(fieldBinding); 
        break;
      case 2:
        localBinding = (LocalVariableBinding)this.binding;
        isFinal = localBinding.isFinal();
        if (!unconditionalFlowInfo.isDefinitelyAssigned(localBinding)) {
          this.bits |= 0x8;
        } else {
          this.bits &= 0xFFFFFFF7;
        } 
        if (unconditionalFlowInfo.isPotentiallyAssigned(localBinding) || (this.bits & 0x80000) != 0) {
          localBinding.tagBits &= 0xFFFFFFFFFFFFF7FFL;
          if (!isFinal && (this.bits & 0x80000) != 0)
            currentScope.problemReporter().cannotReferToNonEffectivelyFinalOuterLocal(localBinding, (ASTNode)this); 
        } 
        if (!isFinal && (localBinding.tagBits & 0x800L) != 0L && (localBinding.tagBits & 0x400L) == 0L) {
          flowContext.recordSettingFinal((VariableBinding)localBinding, (Reference)this, (FlowInfo)unconditionalFlowInfo);
        } else if (isFinal) {
          if ((this.bits & 0x1FE0) == 0) {
            if ((isReachable && isCompound) || !localBinding.isBlankFinal()) {
              currentScope.problemReporter().cannotAssignToFinalLocal(localBinding, (ASTNode)this);
            } else if (unconditionalFlowInfo.isPotentiallyAssigned(localBinding)) {
              currentScope.problemReporter().duplicateInitializationOfFinalLocal(localBinding, (ASTNode)this);
            } else if ((this.bits & 0x80000) != 0) {
              currentScope.problemReporter().cannotAssignToFinalOuterLocal(localBinding, (ASTNode)this);
            } else {
              flowContext.recordSettingFinal((VariableBinding)localBinding, (Reference)this, (FlowInfo)unconditionalFlowInfo);
            } 
          } else {
            currentScope.problemReporter().cannotAssignToFinalOuterLocal(localBinding, (ASTNode)this);
          } 
        } else if ((localBinding.tagBits & 0x400L) != 0L) {
          currentScope.problemReporter().parameterAssignment(localBinding, (ASTNode)this);
        } 
        unconditionalFlowInfo.markAsDefinitelyAssigned(localBinding);
        break;
    } 
    manageEnclosingInstanceAccessIfNecessary(currentScope, (FlowInfo)unconditionalFlowInfo);
    return (FlowInfo)unconditionalFlowInfo;
  }
  
  public FlowInfo analyseCode(BlockScope currentScope, FlowContext flowContext, FlowInfo flowInfo) {
    return analyseCode(currentScope, flowContext, flowInfo, true);
  }
  
  public FlowInfo analyseCode(BlockScope currentScope, FlowContext flowContext, FlowInfo flowInfo, boolean valueRequired) {
    FieldBinding fieldBinding;
    LocalVariableBinding localBinding;
    switch (this.bits & 0x7) {
      case 1:
        if (valueRequired || (currentScope.compilerOptions()).complianceLevel >= 3145728L)
          manageSyntheticAccessIfNecessary(currentScope, flowInfo, true); 
        fieldBinding = (FieldBinding)this.binding;
        if (fieldBinding.isBlankFinal() && currentScope.needBlankFinalFieldInitializationCheck(fieldBinding)) {
          FlowInfo fieldInits = flowContext.getInitsForFinalBlankInitializationCheck(fieldBinding.declaringClass.original(), flowInfo);
          if (!fieldInits.isDefinitelyAssigned(fieldBinding))
            currentScope.problemReporter().uninitializedBlankFinalField(fieldBinding, (ASTNode)this); 
        } 
        break;
      case 2:
        if (!flowInfo.isDefinitelyAssigned(localBinding = (LocalVariableBinding)this.binding))
          currentScope.problemReporter().uninitializedLocalVariable(localBinding, (ASTNode)this); 
        if ((flowInfo.tagBits & 0x3) == 0) {
          localBinding.useFlag = 1;
          break;
        } 
        if (localBinding.useFlag == 0)
          localBinding.useFlag = 2; 
        break;
    } 
    if (valueRequired)
      manageEnclosingInstanceAccessIfNecessary(currentScope, flowInfo); 
    return flowInfo;
  }
  
  public TypeBinding checkFieldAccess(BlockScope scope) {
    FieldBinding fieldBinding = (FieldBinding)this.binding;
    this.constant = fieldBinding.constant((Scope)scope);
    this.bits &= 0xFFFFFFF8;
    this.bits |= 0x1;
    MethodScope methodScope = scope.methodScope();
    if (fieldBinding.isStatic()) {
      ReferenceBinding declaringClass = fieldBinding.declaringClass;
      if (declaringClass.isEnum()) {
        SourceTypeBinding sourceType = scope.enclosingSourceType();
        if (this.constant == Constant.NotAConstant && 
          !methodScope.isStatic && (
          TypeBinding.equalsEquals((TypeBinding)sourceType, (TypeBinding)declaringClass) || TypeBinding.equalsEquals((TypeBinding)sourceType.superclass, (TypeBinding)declaringClass)) && 
          methodScope.isInsideInitializerOrConstructor())
          scope.problemReporter().enumStaticFieldUsedDuringInitialization(fieldBinding, (ASTNode)this); 
      } 
    } else {
      if (scope.compilerOptions().getSeverity(4194304) != 256)
        scope.problemReporter().unqualifiedFieldAccess(this, fieldBinding); 
      if (methodScope.isStatic) {
        scope.problemReporter().staticFieldAccessToNonStaticVariable((ASTNode)this, fieldBinding);
        return fieldBinding.type;
      } 
      scope.tagAsAccessingEnclosingInstanceStateOf(fieldBinding.declaringClass, false);
    } 
    if (isFieldUseDeprecated(fieldBinding, (Scope)scope, this.bits))
      scope.problemReporter().deprecatedField(fieldBinding, (ASTNode)this); 
    if ((this.bits & 0x2000) == 0 && 
      TypeBinding.equalsEquals((TypeBinding)methodScope.enclosingSourceType(), (TypeBinding)(fieldBinding.original()).declaringClass) && 
      methodScope.lastVisibleFieldID >= 0 && 
      fieldBinding.id >= methodScope.lastVisibleFieldID && (
      !fieldBinding.isStatic() || methodScope.isStatic)) {
      scope.problemReporter().forwardReference((Reference)this, 0, fieldBinding);
      this.bits |= 0x20000000;
    } 
    return fieldBinding.type;
  }
  
  public boolean checkNPE(BlockScope scope, FlowContext flowContext, FlowInfo flowInfo, int ttlForFieldCheck) {
    if (!super.checkNPE(scope, flowContext, flowInfo, ttlForFieldCheck)) {
      CompilerOptions compilerOptions = scope.compilerOptions();
      if (compilerOptions.isAnnotationBasedNullAnalysisEnabled && 
        this.binding instanceof FieldBinding)
        return checkNullableFieldDereference((Scope)scope, (FieldBinding)this.binding, (this.sourceStart << 32L) + this.sourceEnd, flowContext, ttlForFieldCheck); 
    } 
    return false;
  }
  
  public void computeConversion(Scope scope, TypeBinding runtimeTimeType, TypeBinding compileTimeType) {
    if (runtimeTimeType == null || compileTimeType == null)
      return; 
    if (this.binding != null && this.binding.isValidBinding()) {
      TypeBinding originalType = null;
      if ((this.bits & 0x1) != 0) {
        FieldBinding field = (FieldBinding)this.binding;
        FieldBinding originalBinding = field.original();
        originalType = originalBinding.type;
      } else if ((this.bits & 0x2) != 0) {
        LocalVariableBinding local = (LocalVariableBinding)this.binding;
        originalType = local.type;
      } 
      if (originalType != null && originalType.leafComponentType().isTypeVariable()) {
        TypeBinding targetType = (!compileTimeType.isBaseType() && runtimeTimeType.isBaseType()) ? 
          compileTimeType : 
          runtimeTimeType;
        this.genericCast = originalType.genericCast(scope.boxing(targetType));
        if (this.genericCast instanceof ReferenceBinding) {
          ReferenceBinding referenceCast = (ReferenceBinding)this.genericCast;
          if (!referenceCast.canBeSeenBy(scope))
            scope.problemReporter().invalidType((ASTNode)this, 
                (TypeBinding)new ProblemReferenceBinding(
                  CharOperation.splitOn('.', referenceCast.shortReadableName()), 
                  referenceCast, 
                  2)); 
        } 
      } 
    } 
    super.computeConversion(scope, runtimeTimeType, compileTimeType);
  }
  
  public void generateAssignment(BlockScope currentScope, CodeStream codeStream, Assignment assignment, boolean valueRequired) {
    int pc;
    FieldBinding codegenBinding;
    LocalVariableBinding localBinding;
    if (assignment.expression.isCompactableOperation()) {
      BinaryExpression operation = (BinaryExpression)assignment.expression;
      int operator = (operation.bits & 0xFC0) >> 6;
      org.eclipse.jdt.internal.compiler.ast.SingleNameReference variableReference;
      if (operation.left instanceof org.eclipse.jdt.internal.compiler.ast.SingleNameReference && (variableReference = (org.eclipse.jdt.internal.compiler.ast.SingleNameReference)operation.left).binding == this.binding) {
        variableReference.generateCompoundAssignment(currentScope, codeStream, (this.syntheticAccessors == null) ? null : this.syntheticAccessors[1], operation.right, operator, operation.implicitConversion, valueRequired);
        if (valueRequired)
          codeStream.generateImplicitConversion(assignment.implicitConversion); 
        return;
      } 
      if (operation.right instanceof org.eclipse.jdt.internal.compiler.ast.SingleNameReference && (
        operator == 14 || operator == 15) && 
        (variableReference = (org.eclipse.jdt.internal.compiler.ast.SingleNameReference)operation.right).binding == this.binding && 
        operation.left.constant != Constant.NotAConstant && (
        operation.left.implicitConversion & 0xFF) >> 4 != 11 && (
        operation.right.implicitConversion & 0xFF) >> 4 != 11) {
        variableReference.generateCompoundAssignment(currentScope, codeStream, (this.syntheticAccessors == null) ? null : this.syntheticAccessors[1], operation.left, operator, operation.implicitConversion, valueRequired);
        if (valueRequired)
          codeStream.generateImplicitConversion(assignment.implicitConversion); 
        return;
      } 
    } 
    switch (this.bits & 0x7) {
      case 1:
        pc = codeStream.position;
        codegenBinding = ((FieldBinding)this.binding).original();
        if (!codegenBinding.isStatic())
          if ((this.bits & 0x1FE0) != 0) {
            ReferenceBinding targetType = currentScope.enclosingSourceType().enclosingTypeAt((this.bits & 0x1FE0) >> 5);
            Object[] emulationPath = currentScope.getEmulationPath(targetType, true, false);
            codeStream.generateOuterAccess(emulationPath, (ASTNode)this, (Binding)targetType, (Scope)currentScope);
          } else {
            generateReceiver(codeStream);
          }  
        codeStream.recordPositionsFrom(pc, this.sourceStart);
        assignment.expression.generateCode(currentScope, codeStream, true);
        fieldStore((Scope)currentScope, codeStream, codegenBinding, (this.syntheticAccessors == null) ? null : this.syntheticAccessors[1], this.actualReceiverType, true, valueRequired);
        if (valueRequired)
          codeStream.generateImplicitConversion(assignment.implicitConversion); 
        return;
      case 2:
        localBinding = (LocalVariableBinding)this.binding;
        if (localBinding.resolvedPosition != -1) {
          assignment.expression.generateCode(currentScope, codeStream, true);
        } else {
          if (assignment.expression.constant != Constant.NotAConstant) {
            if (valueRequired)
              codeStream.generateConstant(assignment.expression.constant, assignment.implicitConversion); 
          } else {
            assignment.expression.generateCode(currentScope, codeStream, true);
            if (valueRequired) {
              codeStream.generateImplicitConversion(assignment.implicitConversion);
            } else {
              switch (localBinding.type.id) {
                case 7:
                case 8:
                  codeStream.pop2();
                  return;
              } 
              codeStream.pop();
            } 
          } 
          return;
        } 
        if (localBinding.type.isArrayType() && 
          assignment.expression instanceof CastExpression && 
          (((CastExpression)assignment.expression).innermostCastedExpression()).resolvedType == TypeBinding.NULL)
          codeStream.checkcast(localBinding.type); 
        codeStream.store(localBinding, valueRequired);
        if ((this.bits & 0x8) != 0)
          localBinding.recordInitializationStartPC(codeStream.position); 
        if (valueRequired)
          codeStream.generateImplicitConversion(assignment.implicitConversion); 
        break;
    } 
  }
  
  public void generateCode(BlockScope currentScope, CodeStream codeStream, boolean valueRequired) {
    FieldBinding codegenField;
    Constant fieldConstant;
    LocalVariableBinding localBinding;
    int pc = codeStream.position;
    if (this.constant != Constant.NotAConstant) {
      if (valueRequired)
        codeStream.generateConstant(this.constant, this.implicitConversion); 
      codeStream.recordPositionsFrom(pc, this.sourceStart);
      return;
    } 
    switch (this.bits & 0x7) {
      case 1:
        codegenField = ((FieldBinding)this.binding).original();
        fieldConstant = codegenField.constant();
        if (fieldConstant != Constant.NotAConstant) {
          if (valueRequired)
            codeStream.generateConstant(fieldConstant, this.implicitConversion); 
          codeStream.recordPositionsFrom(pc, this.sourceStart);
          return;
        } 
        if (codegenField.isStatic()) {
          if (!valueRequired)
            if (TypeBinding.equalsEquals((TypeBinding)(((FieldBinding)this.binding).original()).declaringClass, this.actualReceiverType.erasure()) && (
              this.implicitConversion & 0x400) == 0 && 
              this.genericCast == null) {
              codeStream.recordPositionsFrom(pc, this.sourceStart);
              return;
            }  
          if (this.syntheticAccessors == null || this.syntheticAccessors[0] == null) {
            TypeBinding constantPoolDeclaringClass = CodeStream.getConstantPoolDeclaringClass((Scope)currentScope, codegenField, this.actualReceiverType, true);
            codeStream.fieldAccess((byte)-78, codegenField, constantPoolDeclaringClass);
            break;
          } 
          codeStream.invoke((byte)-72, this.syntheticAccessors[0], null);
          break;
        } 
        if (!valueRequired && (
          this.implicitConversion & 0x400) == 0 && 
          this.genericCast == null) {
          codeStream.recordPositionsFrom(pc, this.sourceStart);
          return;
        } 
        if ((this.bits & 0x1FE0) != 0) {
          ReferenceBinding targetType = currentScope.enclosingSourceType().enclosingTypeAt((this.bits & 0x1FE0) >> 5);
          Object[] emulationPath = currentScope.getEmulationPath(targetType, true, false);
          codeStream.generateOuterAccess(emulationPath, (ASTNode)this, (Binding)targetType, (Scope)currentScope);
        } else {
          generateReceiver(codeStream);
        } 
        if (this.syntheticAccessors == null || this.syntheticAccessors[0] == null) {
          TypeBinding constantPoolDeclaringClass = CodeStream.getConstantPoolDeclaringClass((Scope)currentScope, codegenField, this.actualReceiverType, true);
          codeStream.fieldAccess((byte)-76, codegenField, constantPoolDeclaringClass);
          break;
        } 
        codeStream.invoke((byte)-72, this.syntheticAccessors[0], null);
        break;
      case 2:
        localBinding = (LocalVariableBinding)this.binding;
        if (localBinding.resolvedPosition == -1) {
          if (valueRequired) {
            localBinding.useFlag = 1;
            throw new AbortMethod(CodeStream.RESTART_CODE_GEN_FOR_UNUSED_LOCALS_MODE, null);
          } 
          codeStream.recordPositionsFrom(pc, this.sourceStart);
          return;
        } 
        if (!valueRequired && (this.implicitConversion & 0x400) == 0) {
          codeStream.recordPositionsFrom(pc, this.sourceStart);
          return;
        } 
        if ((this.bits & 0x80000) != 0) {
          checkEffectiveFinality(localBinding, (Scope)currentScope);
          VariableBinding[] path = currentScope.getEmulationPath(localBinding);
          codeStream.generateOuterAccess((Object[])path, (ASTNode)this, (Binding)localBinding, (Scope)currentScope);
          break;
        } 
        codeStream.load(localBinding);
        break;
      default:
        codeStream.recordPositionsFrom(pc, this.sourceStart);
        return;
    } 
    if (this.genericCast != null)
      codeStream.checkcast(this.genericCast); 
    if (valueRequired) {
      codeStream.generateImplicitConversion(this.implicitConversion);
    } else {
      boolean isUnboxing = ((this.implicitConversion & 0x400) != 0);
      if (isUnboxing)
        codeStream.generateImplicitConversion(this.implicitConversion); 
      switch (isUnboxing ? (postConversionType((Scope)currentScope)).id : this.resolvedType.id) {
        case 7:
        case 8:
          codeStream.pop2();
          break;
        default:
          codeStream.pop();
          break;
      } 
    } 
    codeStream.recordPositionsFrom(pc, this.sourceStart);
  }
  
  public void generateCompoundAssignment(BlockScope currentScope, CodeStream codeStream, Expression expression, int operator, int assignmentImplicitConversion, boolean valueRequired) {
    LocalVariableBinding localBinding;
    switch (this.bits & 0x7) {
      case 2:
        localBinding = (LocalVariableBinding)this.binding;
        Reference.reportOnlyUselesslyReadLocal(currentScope, localBinding, valueRequired);
        break;
      case 1:
        reportOnlyUselesslyReadPrivateField(currentScope, (FieldBinding)this.binding, valueRequired);
        break;
    } 
    generateCompoundAssignment(
        currentScope, 
        codeStream, 
        (this.syntheticAccessors == null) ? null : this.syntheticAccessors[1], 
        expression, 
        operator, 
        assignmentImplicitConversion, 
        valueRequired);
  }
  
  public void generateCompoundAssignment(BlockScope currentScope, CodeStream codeStream, MethodBinding writeAccessor, Expression expression, int operator, int assignmentImplicitConversion, boolean valueRequired) {
    FieldBinding codegenField;
    LocalVariableBinding localBinding;
    FieldBinding fieldBinding1;
    Constant assignConstant;
    LocalVariableBinding localVariableBinding1;
    switch (this.bits & 0x7) {
      case 1:
        codegenField = ((FieldBinding)this.binding).original();
        if (codegenField.isStatic()) {
          if (this.syntheticAccessors == null || this.syntheticAccessors[0] == null) {
            TypeBinding constantPoolDeclaringClass = CodeStream.getConstantPoolDeclaringClass((Scope)currentScope, codegenField, this.actualReceiverType, true);
            codeStream.fieldAccess((byte)-78, codegenField, constantPoolDeclaringClass);
            break;
          } 
          codeStream.invoke((byte)-72, this.syntheticAccessors[0], null);
          break;
        } 
        if ((this.bits & 0x1FE0) != 0) {
          ReferenceBinding targetType = currentScope.enclosingSourceType().enclosingTypeAt((this.bits & 0x1FE0) >> 5);
          Object[] emulationPath = currentScope.getEmulationPath(targetType, true, false);
          codeStream.generateOuterAccess(emulationPath, (ASTNode)this, (Binding)targetType, (Scope)currentScope);
        } else {
          codeStream.aload_0();
        } 
        codeStream.dup();
        if (this.syntheticAccessors == null || this.syntheticAccessors[0] == null) {
          TypeBinding constantPoolDeclaringClass = CodeStream.getConstantPoolDeclaringClass((Scope)currentScope, codegenField, this.actualReceiverType, true);
          codeStream.fieldAccess((byte)-76, codegenField, constantPoolDeclaringClass);
          break;
        } 
        codeStream.invoke((byte)-72, this.syntheticAccessors[0], null);
        break;
      case 2:
        localBinding = (LocalVariableBinding)this.binding;
        switch (localBinding.type.id) {
          case 11:
            codeStream.generateStringConcatenationAppend(currentScope, (Expression)this, expression);
            if (valueRequired)
              codeStream.dup(); 
            codeStream.store(localBinding, false);
            return;
          case 10:
            assignConstant = expression.constant;
            if (localBinding.resolvedPosition == -1) {
              if (valueRequired) {
                localBinding.useFlag = 1;
                throw new AbortMethod(CodeStream.RESTART_CODE_GEN_FOR_UNUSED_LOCALS_MODE, null);
              } 
              if (assignConstant == Constant.NotAConstant)
                expression.generateCode(currentScope, codeStream, false); 
              return;
            } 
            if (assignConstant != Constant.NotAConstant && 
              assignConstant.typeID() != 9 && 
              assignConstant.typeID() != 8) {
              int increment;
              switch (operator) {
                case 14:
                  increment = assignConstant.intValue();
                  if (increment != (short)increment)
                    break; 
                  codeStream.iinc(localBinding.resolvedPosition, increment);
                  if (valueRequired)
                    codeStream.load(localBinding); 
                  return;
                case 13:
                  increment = -assignConstant.intValue();
                  if (increment != (short)increment)
                    break; 
                  codeStream.iinc(localBinding.resolvedPosition, increment);
                  if (valueRequired)
                    codeStream.load(localBinding); 
                  return;
              } 
            } 
            break;
        } 
        if (localBinding


          
          .resolvedPosition == -1) {
          assignConstant = expression.constant;
          if (valueRequired) {
            localBinding.useFlag = 1;
            throw new AbortMethod(CodeStream.RESTART_CODE_GEN_FOR_UNUSED_LOCALS_MODE, null);
          } 
          if (assignConstant == Constant.NotAConstant)
            expression.generateCode(currentScope, codeStream, false); 
          return;
        } 
        codeStream.load(localBinding);
        break;
    } 
    int operationTypeID;
    switch (operationTypeID = (this.implicitConversion & 0xFF) >> 4) {
      case 0:
      case 1:
      case 11:
        codeStream.generateStringConcatenationAppend(currentScope, null, expression);
        break;
      default:
        if (this.genericCast != null)
          codeStream.checkcast(this.genericCast); 
        codeStream.generateImplicitConversion(this.implicitConversion);
        if (expression == IntLiteral.One) {
          codeStream.generateConstant(expression.constant, this.implicitConversion);
        } else {
          expression.generateCode(currentScope, codeStream, true);
        } 
        codeStream.sendOperator(operator, operationTypeID);
        codeStream.generateImplicitConversion(assignmentImplicitConversion);
        break;
    } 
    switch (this.bits & 0x7) {
      case 1:
        fieldBinding1 = ((FieldBinding)this.binding).original();
        fieldStore((Scope)currentScope, codeStream, fieldBinding1, writeAccessor, this.actualReceiverType, true, valueRequired);
        return;
      case 2:
        localVariableBinding1 = (LocalVariableBinding)this.binding;
        if (valueRequired)
          switch (localVariableBinding1.type.id) {
            case 7:
            case 8:
              codeStream.dup2();
              break;
            default:
              codeStream.dup();
              break;
          }  
        codeStream.store(localVariableBinding1, false);
        break;
    } 
  }
  
  public void generatePostIncrement(BlockScope currentScope, CodeStream codeStream, CompoundAssignment postIncrement, boolean valueRequired) {
    FieldBinding fieldBinding;
    FieldBinding codegenField;
    TypeBinding operandType;
    LocalVariableBinding localBinding;
    switch (this.bits & 0x7) {
      case 1:
        fieldBinding = (FieldBinding)this.binding;
        reportOnlyUselesslyReadPrivateField(currentScope, fieldBinding, valueRequired);
        codegenField = fieldBinding.original();
        if (codegenField.isStatic()) {
          if (this.syntheticAccessors == null || this.syntheticAccessors[0] == null) {
            TypeBinding constantPoolDeclaringClass = CodeStream.getConstantPoolDeclaringClass((Scope)currentScope, codegenField, this.actualReceiverType, true);
            codeStream.fieldAccess((byte)-78, codegenField, constantPoolDeclaringClass);
          } else {
            codeStream.invoke((byte)-72, this.syntheticAccessors[0], null);
          } 
        } else {
          if ((this.bits & 0x1FE0) != 0) {
            ReferenceBinding targetType = currentScope.enclosingSourceType().enclosingTypeAt((this.bits & 0x1FE0) >> 5);
            Object[] emulationPath = currentScope.getEmulationPath(targetType, true, false);
            codeStream.generateOuterAccess(emulationPath, (ASTNode)this, (Binding)targetType, (Scope)currentScope);
          } else {
            codeStream.aload_0();
          } 
          codeStream.dup();
          if (this.syntheticAccessors == null || this.syntheticAccessors[0] == null) {
            TypeBinding constantPoolDeclaringClass = CodeStream.getConstantPoolDeclaringClass((Scope)currentScope, codegenField, this.actualReceiverType, true);
            codeStream.fieldAccess((byte)-76, codegenField, constantPoolDeclaringClass);
          } else {
            codeStream.invoke((byte)-72, this.syntheticAccessors[0], null);
          } 
        } 
        if (this.genericCast != null) {
          codeStream.checkcast(this.genericCast);
          operandType = this.genericCast;
        } else {
          operandType = codegenField.type;
        } 
        if (valueRequired)
          if (codegenField.isStatic()) {
            switch (operandType.id) {
              case 7:
              case 8:
                codeStream.dup2();
                break;
              default:
                codeStream.dup();
                break;
            } 
          } else {
            switch (operandType.id) {
              case 7:
              case 8:
                codeStream.dup2_x1();
                break;
              default:
                codeStream.dup_x1();
                break;
            } 
          }  
        codeStream.generateImplicitConversion(this.implicitConversion);
        codeStream.generateConstant(postIncrement.expression.constant, this.implicitConversion);
        codeStream.sendOperator(postIncrement.operator, this.implicitConversion & 0xF);
        codeStream.generateImplicitConversion(postIncrement.preAssignImplicitConversion);
        fieldStore((Scope)currentScope, codeStream, codegenField, (this.syntheticAccessors == null) ? null : this.syntheticAccessors[1], this.actualReceiverType, true, false);
        return;
      case 2:
        localBinding = (LocalVariableBinding)this.binding;
        Reference.reportOnlyUselesslyReadLocal(currentScope, localBinding, valueRequired);
        if (localBinding.resolvedPosition == -1) {
          if (valueRequired) {
            localBinding.useFlag = 1;
            throw new AbortMethod(CodeStream.RESTART_CODE_GEN_FOR_UNUSED_LOCALS_MODE, null);
          } 
          return;
        } 
        if (TypeBinding.equalsEquals(localBinding.type, (TypeBinding)TypeBinding.INT)) {
          if (valueRequired)
            codeStream.load(localBinding); 
          if (postIncrement.operator == 14) {
            codeStream.iinc(localBinding.resolvedPosition, 1);
            break;
          } 
          codeStream.iinc(localBinding.resolvedPosition, -1);
          break;
        } 
        codeStream.load(localBinding);
        if (valueRequired)
          switch (localBinding.type.id) {
            case 7:
            case 8:
              codeStream.dup2();
              break;
            default:
              codeStream.dup();
              break;
          }  
        codeStream.generateImplicitConversion(this.implicitConversion);
        codeStream.generateConstant(postIncrement.expression.constant, this.implicitConversion);
        codeStream.sendOperator(postIncrement.operator, this.implicitConversion & 0xF);
        codeStream.generateImplicitConversion(postIncrement.preAssignImplicitConversion);
        codeStream.store(localBinding, false);
        break;
    } 
  }
  
  public void generateReceiver(CodeStream codeStream) {
    codeStream.aload_0();
  }
  
  public TypeBinding[] genericTypeArguments() {
    return null;
  }
  
  public boolean isEquivalent(Reference reference) {
    char[] otherToken = null;
    if (reference instanceof org.eclipse.jdt.internal.compiler.ast.SingleNameReference) {
      otherToken = ((org.eclipse.jdt.internal.compiler.ast.SingleNameReference)reference).token;
    } else if (reference instanceof FieldReference) {
      FieldReference fr = (FieldReference)reference;
      if (fr.receiver.isThis() && !(fr.receiver instanceof org.eclipse.jdt.internal.compiler.ast.QualifiedThisReference))
        otherToken = fr.token; 
    } 
    return (otherToken != null && CharOperation.equals(this.token, otherToken));
  }
  
  public LocalVariableBinding localVariableBinding() {
    switch (this.bits & 0x7) {
      case 2:
        return (LocalVariableBinding)this.binding;
    } 
    return null;
  }
  
  public VariableBinding nullAnnotatedVariableBinding(boolean supportTypeAnnotations) {
    switch (this.bits & 0x7) {
      case 1:
      case 2:
        if (supportTypeAnnotations || (
          ((VariableBinding)this.binding).tagBits & 0x180000000000000L) != 0L)
          return (VariableBinding)this.binding; 
        break;
    } 
    return null;
  }
  
  public int nullStatus(FlowInfo flowInfo, FlowContext flowContext) {
    if ((this.implicitConversion & 0x200) != 0)
      return 4; 
    LocalVariableBinding local = localVariableBinding();
    if (local != null)
      return flowInfo.nullStatus(local); 
    return super.nullStatus(flowInfo, flowContext);
  }
  
  public void manageEnclosingInstanceAccessIfNecessary(BlockScope currentScope, FlowInfo flowInfo) {
    if (((this.bits & 0x1FE0) == 0 && (this.bits & 0x80000) == 0) || this.constant != Constant.NotAConstant)
      return; 
    if ((this.bits & 0x7) == 2) {
      LocalVariableBinding localVariableBinding = (LocalVariableBinding)this.binding;
      if (localVariableBinding != null) {
        if ((localVariableBinding.tagBits & 0x100L) != 0L)
          return; 
        switch (localVariableBinding.useFlag) {
          case 1:
          case 2:
            currentScope.emulateOuterAccess(localVariableBinding);
            break;
        } 
      } 
    } 
  }
  
  public void manageSyntheticAccessIfNecessary(BlockScope currentScope, FlowInfo flowInfo, boolean isReadAccess) {
    if ((flowInfo.tagBits & 0x1) != 0)
      return; 
    if (this.constant != Constant.NotAConstant)
      return; 
    if ((this.bits & 0x1) != 0) {
      FieldBinding fieldBinding = (FieldBinding)this.binding;
      FieldBinding codegenField = fieldBinding.original();
      if ((this.bits & 0x1FE0) != 0 && (
        codegenField.isPrivate() || (
        codegenField.isProtected() && 
        codegenField.declaringClass.getPackage() != currentScope.enclosingSourceType().getPackage()))) {
        if (this.syntheticAccessors == null)
          this.syntheticAccessors = new MethodBinding[2]; 
        this.syntheticAccessors[isReadAccess ? 0 : 1] = 
          (MethodBinding)((SourceTypeBinding)currentScope.enclosingSourceType()
          .enclosingTypeAt((this.bits & 0x1FE0) >> 5)).addSyntheticMethod(codegenField, isReadAccess, false);
        currentScope.problemReporter().needToEmulateFieldAccess(codegenField, (ASTNode)this, isReadAccess);
        return;
      } 
    } 
  }
  
  public TypeBinding postConversionType(Scope scope) {
    BaseTypeBinding baseTypeBinding;
    TypeBinding typeBinding1, convertedType = this.resolvedType;
    if (this.genericCast != null)
      convertedType = this.genericCast; 
    int runtimeType = (this.implicitConversion & 0xFF) >> 4;
    switch (runtimeType) {
      case 5:
        baseTypeBinding = TypeBinding.BOOLEAN;
        break;
      case 3:
        baseTypeBinding = TypeBinding.BYTE;
        break;
      case 4:
        baseTypeBinding = TypeBinding.SHORT;
        break;
      case 2:
        baseTypeBinding = TypeBinding.CHAR;
        break;
      case 10:
        baseTypeBinding = TypeBinding.INT;
        break;
      case 9:
        baseTypeBinding = TypeBinding.FLOAT;
        break;
      case 7:
        baseTypeBinding = TypeBinding.LONG;
        break;
      case 8:
        baseTypeBinding = TypeBinding.DOUBLE;
        break;
    } 
    if ((this.implicitConversion & 0x200) != 0)
      typeBinding1 = scope.environment().computeBoxingType((TypeBinding)baseTypeBinding); 
    return typeBinding1;
  }
  
  public StringBuffer printExpression(int indent, StringBuffer output) {
    return output.append(this.token);
  }
  
  public TypeBinding reportError(BlockScope scope) {
    this.constant = Constant.NotAConstant;
    if (this.binding instanceof org.eclipse.jdt.internal.compiler.lookup.ProblemFieldBinding) {
      scope.problemReporter().invalidField(this, (FieldBinding)this.binding);
    } else if (this.binding instanceof ProblemReferenceBinding || this.binding instanceof org.eclipse.jdt.internal.compiler.lookup.MissingTypeBinding) {
      scope.problemReporter().invalidType((ASTNode)this, (TypeBinding)this.binding);
    } else {
      scope.problemReporter().unresolvableReference(this, this.binding);
    } 
    return null;
  }
  
  public TypeBinding resolveType(BlockScope scope) {
    if (this.actualReceiverType != null) {
      this.binding = (Binding)scope.getField(this.actualReceiverType, this.token, (InvocationSite)this);
    } else {
      this.actualReceiverType = (TypeBinding)scope.enclosingSourceType();
      this.binding = scope.getBinding(this.token, this.bits & 0x7, (InvocationSite)this, true);
    } 
    if (this.binding.isValidBinding()) {
      TypeBinding type;
      switch (this.bits & 0x7) {
        case 3:
        case 7:
          if (this.binding instanceof VariableBinding) {
            TypeBinding variableType;
            VariableBinding variable = (VariableBinding)this.binding;
            if (this.binding instanceof LocalVariableBinding) {
              this.bits &= 0xFFFFFFF8;
              this.bits |= 0x2;
              if (!variable.isFinal() && (this.bits & 0x80000) != 0 && 
                (scope.compilerOptions()).sourceLevel < 3407872L)
                scope.problemReporter().cannotReferToNonFinalOuterLocal((LocalVariableBinding)variable, (ASTNode)this); 
              variableType = variable.type;
              this.constant = ((this.bits & 0x2000) == 0) ? variable.constant((Scope)scope) : Constant.NotAConstant;
            } else {
              variableType = checkFieldAccess(scope);
            } 
            if (variableType != null) {
              this.resolvedType = 
                
                variableType = ((this.bits & 0x2000) == 0) ? variableType.capture((Scope)scope, this.sourceStart, this.sourceEnd) : variableType;
              if ((variableType.tagBits & 0x80L) != 0L) {
                if ((this.bits & 0x2) == 0)
                  scope.problemReporter().invalidType((ASTNode)this, variableType); 
                return null;
              } 
            } 
            return variableType;
          } 
          this.bits &= 0xFFFFFFF8;
          this.bits |= 0x4;
        case 4:
          this.constant = Constant.NotAConstant;
          type = (TypeBinding)this.binding;
          if (isTypeUseDeprecated(type, (Scope)scope))
            scope.problemReporter().deprecatedType(type, (ASTNode)this); 
          type = scope.environment().convertToRawType(type, false);
          return this.resolvedType = type;
      } 
    } 
    return this.resolvedType = reportError(scope);
  }
  
  public void traverse(ASTVisitor visitor, BlockScope scope) {
    visitor.visit(this, scope);
    visitor.endVisit(this, scope);
  }
  
  public void traverse(ASTVisitor visitor, ClassScope scope) {
    visitor.visit(this, scope);
    visitor.endVisit(this, scope);
  }
  
  public String unboundReferenceErrorName() {
    return new String(this.token);
  }
  
  public char[][] getName() {
    return new char[][] { this.token };
  }
}
